OBJ

  debug  :  "FullDuplexSerial"
  SerIn  :  "FullDuplexSerial"

CON

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
   
  ' Set pins and vaud rate for serial in
  SerIn_Rx = 0                            ' Arduino to Propeller (don't forget 1K resistor!)
  SerIn_Tx = 1                            ' Not used here
  SerIn_Baud = 9600

  ' Set pins and baud rate for serial monitor
  debug_Rx = 31
  debug_Tx = 30
  debug_Baud = 115200

VAR

  long stack[50]                         ' Stack space for second cog

Pub Go

  debug.start(debug_Rx, debug_Tx, 0, debug_Baud)   ' Initialize comm for Serial Terminal
  SerIn.start(SerIn_Rx, SerIn_Tx, 0, SerIn_Baud)   ' Initialize comms for serial input
  cognew(SerialIn,@stack)            
  SerialMonitor                   

Pub SerialIn | cmd

  SerIn.rxFlush                          ' Empty buffer for data from serial input
  repeat
    repeat until (SerIn.rx == "!")       ' Wait for qualifier character
    cmd := SerIn.rx                      ' Get first character
    debug.tx(cmd)                        '   Display character (for debugging)
    cmd := SerIn.rx                      ' Get second character
    debug.tx(cmd)                           
    debug.tx(13)

Pub SerialMonitor
  debug.rxFlush                          ' Empty buffer for data from PC
  repeat
    SerIn.tx(debug.rx)                   ' Display data in Serial Terminal       